"""
*  \brief     template.py
*  \details   Python script for final submission
*  \author    Mateo Haro
*  \version   1.0
*  \date      2022-10-23
*  \pre       None
*  \copyright (c) 2022 CSEM
*
*   CSEM S.A.
*   Jaquet-Droz 1
*   CH-2000 Neuchâtel
*   http://www.csem.ch
*
*
*   THIS PROGRAM IS CONFIDENTIAL AND CANNOT BE DISTRIBUTED
*   WITHOUT THE CSEM PRIOR WRITTEN AGREEMENT.
*
*   CSEM is the owner of this source code and is authorised to use, to modify
*   and to keep confidential all new modifications of this code.
*
"""

# import the necessary libraries here
import os
from demo_read_file import read_data
import librosa

# PLEASE DON'T CHANGE THE NAME OF THE FUNCTION
def template(*, model_filename=None, testset_directory=None):
    # 1. the following loop iterates through all the .dat files in the test set directory
    # It is also suggested to label the audio sample at this stage
    for filename in os.listdir(testset_directory):
        if filename.endswith('.dat'):
            print("reads a .dat file")
            # put here the code that loads a .dat file
            path = os.path.join(testset_directory, filename)
            read_data(path, testset_directory)
            # you can use the script example available on our website: https://portal.csem.ch:9120/scripts/demo_read_file.py
            # use the function from the demo: read_data(filename, testset_directory)
            # this function will read a .dat file and store all the samples in a .wav format in a directory

    # 2. then load all the .wav files (with librosa library for example)
    audio_data = []
    for filename in os.listdir(testset_directory):
        if filename.endswith('.wav'):
            path = os.path.join(testset_directory, filename)
            audio_signal, sample_rate = librosa.load(path, sr=None)
            # 3. Do audio processing in case your application needs any
            # 4. Save the data in the framework you are using for your model (in a tensorflow dataset for example)
            audio_data.append(audio_signal) # in this example the data is saved in an array
            print("audio file read")

    # 5. laod your model
    # 6. proceeed to inference on the entire dataset (no matter the audio processing steps, you need to use information from all the samples available in the .dat file)
    # 7. Compute the confusion matrix
    # 8. return a confusion matrix in a 2D array with in the first dimension the true labels and in the second dimension the predicted labels

    # this is an example of the format of the confusion matrix in the case of binary classification
    confusion_matrix_example = [[24,2],
                                [4,30]]

    return confusion_matrix_example

# If you would like to test this demo template run this script
print(template(model_filename=None, testset_directory="data"))